# Coverage for Doctrine_Sequence_Firebird

Back to coverage report

1 | <?php
2 | /*
3 | * $Id: Firebird.php 2963 2007-10-21 06:23:59Z Jonathan.Wage $
4 | *
5 | * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6 | * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7 | * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8 | * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9 | * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10 | * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11 | * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12 | * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13 | * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14 | * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15 | * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16 | *
17 | * This software consists of voluntary contributions made by many individuals
18 | * and is licensed under the LGPL. For more information, see
19 | * <http://www.phpdoctrine.org>.
20 | */
21 | Doctrine::autoload('Doctrine_Sequence');
22 | /**
23 | * Doctrine_Sequence_Firebird
24 | *
25 | * @package Doctrine
26 | * @subpackage Sequence
27 | * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
28 | * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
29 | * @link www.phpdoctrine.org
30 | * @since 1.0
31 | * @version $Revision: 2963 $
32 | */
33 | class Doctrine_Sequence_Firebird extends Doctrine_Sequence
34 | {
35 | /**
36 | * Returns the next free id of a sequence
37 | *
38 | * @param string $seqName name of the sequence
39 | * @param bool when true missing sequences are automatic created
40 | *
41 | * @return integer next id in the given sequence
42 | */
43 | public function nextID($seqName, $onDemand = true)
44 | {
45 | $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
46 |
47 | $query = 'SELECT GEN_ID(' . $sequenceName . ', 1) as the_value FROM RDB$DATABASE';
48 | try {
49 |
50 | $result = $this->conn->fetchOne($query);
51 |
52 | } catch(Doctrine_Connection_Exception $e) {
53 | if ($onDemand && $e->getPortableCode() == Doctrine::ERR_NOSUCHTABLE) {
54 | // Since we are creating the sequence on demand
55 | // we know the first id = 1 so initialize the
56 | // sequence at 2
57 | try {
58 | $result = $this->conn->export->createSequence($seqName, 2);
59 | } catch(Doctrine_Exception $e) {
60 | throw new Doctrine_Sequence_Exception('on demand sequence ' . $seqName . ' could not be created');
61 | }
62 | // First ID of a newly created sequence is 1
63 | // return 1;
64 | // BUT generators are not always reset, so return the actual value
65 | return $this->currID($seqName);
66 | }
67 | throw $e;
68 | }
69 | return $result;
70 | }
71 |
72 | /**
73 | * Returns the autoincrement ID if supported or $id or fetches the current
74 | * ID in a sequence called: $table.(empty($field) ? '' : '_'.$field)
75 | *
76 | * @param string name of the table into which a new row was inserted
77 | * @param string name of the field into which a new row was inserted
78 | */
79 | public function lastInsertId($table = null, $field = null)
80 | {
81 | return $this->conn->getDbh()->lastInsertId();
82 | }
83 |
84 | /**
85 | * Returns the current id of a sequence
86 | *
87 | * @param string $seqName name of the sequence
88 | *
89 | * @return integer current id in the given sequence
90 | */
91 | public function currId($seqName)
92 | {
93 | $sequenceName = $this->conn->quoteIdentifier($this->conn->formatter->getSequenceName($seqName), true);
94 |
95 |
96 | $query = 'SELECT GEN_ID(' . $sequenceName . ', 0) as the_value FROM RDB$DATABASE';
97 | try {
98 | $value = $this->conn->fetchOne($query);
99 | } catch(Doctrine_Connection_Exception $e) {
100 | throw new Doctrine_Sequence_Exception('Unable to select from ' . $seqName);
101 | }
102 | if ( ! is_numeric($value)) {
103 | throw new Doctrine_Sequence_Exception('could not find value in sequence table');
104 | }
105 | return $value;
106 | }
107 | }